#ifndef _ASM_INCLUDED_
#define _ASM_INCLUDED_     /* definujeme, ze je inkludovan asm.h */
/*
 *  asm.h
 *  funkce pro klavesnici a tisk na monitor, na nejnizsi urovni 
 *  funkce:   
 *    getch()     - pocka na stisk klavesy a vrati jeji hodnotu
 *    putch()     - vypiskne znak do konzole
 */  

#define _Cdecl

#include <global.h>
/*
 *  makra dulezita pro Turbo C
 */ 
void          _Cdecl	__cli__        (void);
void          _Cdecl	__sti__        (void);
void          _Cdecl	__int__        (int interruptnum);
void          _Cdecl	__outportb__   (int portid, unsigned char value);
unsigned char _Cdecl  __inportb__    (int portid);

/*
 *  getch()
 *  pocka na stisk klavesy, vrati jeji ASCII hodnotu 
 */ 
char getch() {
  _AX = 0x00;
  __int__(0x16);
  return _AL;
}

/*
 *  putch()
 *  vytiskne ASCII znak
 */ 
void putch(char s) {
  if((s!='\r') && (s!='\n') && (s!='\t') && (s!='\b')) { /* barevne NEtisknout tyto znaky */
    _AL = 0;
    _CX = 1;
    _BH = 0;
    _BL = TEXT_COL;
    _AH = 0x09;
    __int__(0x10);
  }
  
  _AL = s;
  _AH = 0x0e;
  _BL = 0x07;
  __int__(0x10);
}
#endif
