#ifndef _MEM_INCLUDED_
#define _MEM_INCLUDED_     /* definujeme, ze je inkludovan mem.h */
/*
 *  mem.h
 *  prace s polem bajtu
 *  kopirovani, porovnavani, presouvani...  
 *  funkce:
 *    memset()      - nastavi pametovy blok jinym blokem
 *    memcpy()      - zkopiruje blok pameti
 *    memcmp()      - porovna cast pameti
 */  


#include <asm.h>  /* putch() */

/*
 *  memset()
 *  nastavi pametovy blok 1 pametovym blokem 2 o <count> bytech
 */  
void *memset(void *s, int c, unsigned count) {
  char *xs = (char *) s;
  while (count--)	*xs++ = c;
  return s;
}

/*
 *  memcpy()
 *  zkopiruje do pameti <dest> pamet <src>, o delce <count>
 */ 
void *memcpy(void* dest, const void* src, unsigned int count) {
  unsigned char* ds = (unsigned char*)dest;
  unsigned char* ss = (unsigned char*)src;
  unsigned int i;
    for (i = 0; i < count; i++)
      ds[i] = ss[i];
    return dest;
}

/*
 *  memcmp()
 *  porovna pametovy blok 1 s pametovym blokem 2 o <count> bytech
 */  
int memcmp(const void *cs,const void *ct,unsigned count) {
  const char *su1;
  const char *su2;
  signed char res = 0;
  for( su1 = (char *)cs, su2 = (char *)ct; 0 < count; ++su1, ++su2, count--)
  if ((res = *su1 - *su2) != 0) break;
  return res;
}

#endif
